#ifndef GHOSTAGENT_HH
#define GHOSTAGENT_HH

//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.0

//----------------------------------------------------------------------------

#include "Agent.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#define LAY_CLYDE_CHAR   'C'
#define LAY_INKY_CHAR    'I'
#define LAY_BLINKY_CHAR  'B'

class ClydeGhostAgent : public Agent
{
public:

  ClydeGhostAgent(string s, char c, int i, int x = 0, int y = 0) : Agent(s, c, i, x, y) { }
  ~ClydeGhostAgent() { }

  void update(const GameState &, BlockMaze *);

};

//----------------------------------------------------------------------------

class InkyGhostAgent : public Agent
{
public:

  InkyGhostAgent(string s, char c, int i, int x = 0, int y = 0) : Agent(s, c, i, x, y) { inky_mode = true; mode_wait_counter = 0; }
  ~InkyGhostAgent() { }

  void update(const GameState &, BlockMaze *);

  bool inky_mode;            // are we being ourself, or clyde right now?
  int mode_wait_counter;     // how much longer we will be in this mode before possibly changing
};

//----------------------------------------------------------------------------

class BlinkyGhostAgent : public Agent
{
public:

  BlinkyGhostAgent(string s, char c, int i, int x = 0, int y = 0) : Agent(s, c, i, x, y) { }
  ~BlinkyGhostAgent() { }

  void update(const GameState &, BlockMaze *);

};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
